%global githash c1ad650
%global gitdate 20210824

Name:           fbgemm
Version:        0
Release:        %{gitdate}.git%{githash}%{?dist}
Summary:        Facebook GEneral Matrix Multiplication
License:        BSD
URL:            https://github.com/pytorch/fbgemm

Source0:        %{name}.tar.xz

ExclusiveArch:  %{ix86} x86_64

BuildRequires:  cmake gcc-c++ python3
BuildRequires:  asmjit-devel cpuinfo-devel


%global _lto_cflags %{nil}
%global __cmake_in_source_build 1


%description
Facebook GEneral Matrix Multiplication

%package        devel
Summary:        Development files
Requires:       %{name} = %{version}-%{release}

%description    devel
This package contains the development files for %{name}.



%prep
%setup -q -n %{name}
# only external
rm -rf third_party


%build

sed -i 's|hidden|default|' CMakeLists.txt
sed -i '/NOT TARGET cpuinfo/,/^endif/d' CMakeLists.txt
sed -i '/NOT TARGET asmjit/,/^endif/d' CMakeLists.txt
sed -i '/fbgemm asmjit cpuinfo/d' CMakeLists.txt
sed -i 's|$<BUILD_INTERFACE:asmjit>|asmjit|' CMakeLists.txt
sed -i 's|$<BUILD_INTERFACE:cpuinfo>|cpuinfo|' CMakeLists.txt
sed -i 's|fbgemm PROPERTIES|fbgemm PROPERTIES SOVERSION 1 VERSION 1.0|' CMakeLists.txt

mkdir build
pushd build

export CXX_FLAGS="%{optflags} -fpermissive"
%cmake .. \
       -DCMAKE_SKIP_RPATH=ON \
       -DCMAKE_VERBOSE_MAKEFILE=OFF \
       -DCMAKE_BUILD_TYPE=RelWithDebInfo \
       -DCMAKE_INSTALL_LIBDIR=%{_libdir} \
       -DFBGEMM_LIBRARY_TYPE="shared" \
       -DFBGEMM_BUILD_TESTS=OFF \
       -DFBGEMM_BUILD_BENCHMARKS=OFF \
       -DCPUINFO_SOURCE_DIR="%{_incudedir}"

make %{?_smp_mflags}

popd


%install

rm -rf %{buildroot}

pushd build
make install DESTDIR=%{buildroot}
popd

for f in `find ./src -type f -name '*.h'`;
do
  install -D -pm 644 $f %{buildroot}%{_includedir}/%{name}/$f
done


%files
%license LICENSE
%doc README.md
%{_libdir}/*.so.*

%files devel
%license LICENSE
%doc README.md
%{_includedir}/*
%{_libdir}/*.so
%{_datadir}/cmake/*


%changelog
* Fri Sep 25 2020 Cristian Balint <cristian.balint@gmail.com> - 0.1
- initial build
